#include "processingconfig.h"

std::ostream & operator<< (std::ostream & o, ProcessingConfig p) {
    o << "Colour space / depth: " << p.colourSpace << " " << static_cast<int>(p.colourDepth) << std::endl;
    o << "Ref buf size: " << p.referenceBufferSize << std::endl;
    o << "BG ref frames: " << p.backgroundReferenceFrames << std::endl;
    o << "BG sigma estimation: " << p.backgroundAppearanceSigmaEstimation << " with delay " << p.backgroundAppearanceSigmaEstimationDelay << std::endl;
    o << "BG default app. sigma: " << p.backgroundAppearanceSigma << std::endl;
    o << "BG spatial modelling: " << p.backgroundSpatialModelling
      << ", sigma / inv sigma: " << p.backgroundSpatialSigma << " / " << p.backgroundInverseSpatialSigma
      << ", radius: " << p.backgroundSpatialRadius << std::endl;
    o << "Selective update: " << p.backgroundSelectiveUpdate
      << ", cutoff " << p.backgroundSelectiveUpdateCutoff
      << ", sigmaTSquare " << p.backgroundSelectiveUpdateSigmaTsquare << std::endl;
    o << "Foreground model: " << p.foregroundModelEnabled
      << ", delay " << p.foregroundStartDelay
      << ", reference frames " << p.foregroundReferenceFrames
      << ", mixing factor " << p.foregroundMixingFactor << std::endl;
    o << "FG spatial modeling: " << p.foregroundSpatialModelling
      << ", sigma " << p.foregroundSpatialSigma
      << ", radius " << p.foregroundSpatialRadius << std::endl;
    o << "ROI analysis: " << p.roiAnalysis
      << ", block size " << p.blockWidth << "x" << p.blockHeight << std::endl;
    o << "Morphological filtering: " << p.morphologicalFilter << std::endl;
    o << "Spatial marginal conditioning: " << p.spatialMarginalConditioning << std::endl;
    o << "Particle filter: " << p.particleFilterEnabled
      << ", beta " << p.particleFilterParticleLikelihoodBeta
      << ", maxRegions " << p.particleFilterMaxRegions
      << " of minSize " << p.particleFilterMinRegionSize
      << "; maxParticles " << p.particleFilterMaxParticles
      << " of size [" << p.particleFilterMinParticleRadius << " -- " << p.particleFilterMaxParticleRadius << "]"
      << ", jitter " << p.particleFilterRandomCentreJitter << ", size factor " << p.particleFilterRandomSizeFactor << std::endl;

    return o;
}
